package server

import (
	def "git.pbiernat.dev/egommerce/basket-service/internal/app/definition"
	"git.pbiernat.dev/egommerce/basket-service/internal/app/service"
	"github.com/gofiber/fiber/v2"
)

func (s *Server) CheckoutHandler(c *fiber.Ctx) error {
	reqID, _ := s.GetRequestID(c)
	data := new(def.BasketCheckoutRequest)
	if err := c.BodyParser(data); err != nil {
		return err
	}

	basketID := data.BasketID
	// vlaidate, pre check... etc
	basket := service.NewBasketService(s.db, s.ebCh, s.log)
	basket.Checkout(reqID, basketID)

	return c.JSON(&def.BasketCheckoutResponse{
		ID: data.BasketID,
	})
}
